///////////////////**************Introduction to program****************///////////////////
/*    Handles Student Database for the first year students of IITB.
   Meant for both of administrator and student....
      For Administrator It Gives all options of Entry of details of students , modifying that
       and even Display options as can be seen on scrolling down......
    For student it only gives option of Display where he/she can see his/her marksheet...
  The description of functions is as done below......*/


//////////////******************* Header files included*****************/////////////////
#include<iostream>
#include<cstring>
#include<cstdio>
#include<ctype.h>
#include<cassert>
#include "ezwin.h"
#include "SimpleWindow.h"
using namespace std;

//////////////***********************structures*******************************///////////////
 struct DOB
     {
           short int date;
           short int month;
           short int year; 
     }; 
struct student_info                        //To hold the Information about students in Database
{
     char name[25];              
     char roll_no[12];
     char branch[22];
     short int division;
     DOB dob;
     short int hostel_no;
     int room_no;
     char home_state[22]; 
     char extra_act[5];
     char blood_group[5];
     char password[22];
}student;

struct result_info               //To hold marks in various courses student is enrolled in
{
     char roll_no[12];
     int marks[6]; 
     char extra_act[4];//for PP or NP grade in NSS/NCC/NSO
     float SPI; 

}result;

      struct course_details
      {
            char course_name[10];
            char instructor_name[22];
            short int credits;       
      }; 
struct course_info            //To maintain a course file listing courses for each division and instructor name and credits
{
      short int division;  
      course_details subject[6];

}course;

struct index_info      //For index file holding Roll no. and record number in student file.... for easy searching
{
      char roll_no[12]; 
      int record;
}index1;


///////////*******************Functions prototype************************//////////////////////

void administrator_login();
void student_login();
void administrator_menu();
      void student_processing_menu();
            void entry_newstud();
               void get_student_info();
               void con_toupper(char *);
               void initialize_result();
               int check_roll(char *);
               void get_name(char *);
               void get_dob(DOB &);
               void get_division(short int &);
               int check_roll_no(char *);
               void get_hostel(student_info &);
               void get_extra(char *);
               void get_state(char *);
               void get_blood_group(char *);
               void get_password(char *);
               void get_branch(char *);
            void modification_stud();
               int get_index_of_rollno(char * );
               void display_students_info(struct student_info &);
            void deletion_stud();
      void result_processing_menu();
            void modification_marks();
      void display_menu();
            void student_file_display();
            void course_file_display1();
            void Marksheet1();
              void query1();
              void query2();
              void query3();
              void query4();
              void query5();
              void query6();             
void studentmenu(student_info &);
      void course_file_display2(student_info &);
      void Marksheet2(student_info &);

///////////****************Global variables**************************////////
     FILE *Pstudent, *Presult , *Pcourse ,*Pindex;
     int input_variable,a=1;
     char password_variable[12] , roll_variable[11];


/////////////////////////////////******************Main function*************************/////////////////////////////////////////////////////
 int ApiMain()
{  
    // Opens the First menu thats asks whether the user is a adminstrator or a Student and accordingly calls the corresponding functions
    //  No input . Just a simple use of switch to call various functions according to need.
  
   SimpleWindow window1("Student database management",30.0,15.0,Position(0.0,0.0));
   do
    { 
       window1.Open();
       window1.RenderText(Position(12.0,2.0),Position(18.0,3.0),"WELCOME TO STUDENT DATABASE MANAGEMENT " , Black);
       window1.RenderText(Position(13.0,5.0),Position(17.0,6.0),"1) Administrator " , Black);
       window1.RenderText(Position(13.0,8.0),Position(17.0,9.0),"2)Student " , Black);
       window1.RenderText(Position(13.0,11.0),Position(17.0,12.0),"3) Exit " , Black);
       window1.RenderText(Position(9.0,13.0),Position(21.0,14.0),"Switch to the terminal window for the input " , Black);
       cin>>input_variable;
       switch(input_variable)
        {
              case 1:
                             window1.Close();
                             administrator_login();//defined on line number 156
                             break;
             case 2:
                             window1.Close();
                             student_login();//defined on line number 173
                             break;
             case 3:
                             window1.Close();
                             exit(0);
             default:  cout<<"   WRONG Input.....\n";
         }
     }while(input_variable!=3);
 }
///////////////////************************End of apimain()**********************//////////////////



//////////////////////////****************Functions descriptions*****************///////////////
void administrator_login()
{  //Asks adminstrator to enter password .
   //If matches calls adminstrator_menu() otherwise gives chances three times and then exits to main menu 
   //Administrator password is a fixed one that has been pre decided by us as admin_iitb_2010
    do
        {
            cout<<"\n\n Enter Password......";
            cin>>password_variable;
            a++;
            if(strcmp(password_variable,"admin_iitb_2010")==0)
             {
                 a=4; administrator_menu();        //defined on line number 215
             }
        }while(a<4);
}

//////////////////////////////////////////////////////////////////////////////////////////////
void student_login()
{  
     /* Input:-     Student's roll number and password
      Output:-    Calls menu fuction if both matches
      It moves through both Index and student file
      checks whether entered roll number exists in Index file or not..
      If yes then asks for password ..
      Matches for it in student file and if matches then calls
      student_menu() function 
   
      */
   int p=0;                //A flag meant for checking whether roll number was found or not
   cout<<"\n\n Enter student Roll number\n";
   cin>>roll_variable;
   Pindex=fopen("index.abc","rb");
   assert(Pindex!=NULL);     //A check for proper opening of file
   while(!feof(Pindex))
    {
        fread(&index1, sizeof(index1) , 1.0 , Pindex);
        if( index1.roll_no== roll_variable)
           {
              p=1;
              cout<<"\n\nEnter password...";
              cin>>password_variable;
              Pstudent=fopen("Student.abc", "rb");
             assert(Pstudent!= NULL);
             fseek(Pstudent , ( index1.record -1)*sizeof(student) , 0);
             fread(&student , sizeof(student) , 1.0 , Pstudent );
             if(strcmp(password_variable , student.password)==0) 
                        studentmenu(student);      //call of function with student_info structure variable as parameter.  defined on line number 402
             else
                   cout<<"\n WRONG PASSWORD.....";
             fclose(Pstudent);
          }
   }
   if(p==0)
      cout<<"\n Roll number not found....";
   fclose(Pindex);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

void administrator_menu()
{  /* Displays the administrator His menu
      According to the choice given calls the corresponding function
     */
   SimpleWindow window2("MENU TO ADMINTRATOR", 30.0 , 15.0, Position(0.0,0.0));
   do
    {
       window2.Open();
       window2.RenderText( Position(12.0,2.0) , Position(18.0,3.0) , "Admintrator Menu  " , Blue);
       window2.RenderText( Position(13.0,4.0) , Position(17.0,5.0) , "1) Student Processing Menu  " , Black);
       window2.RenderText( Position(13.0,6.0) , Position(17.0,7.0) , "2) Result Processing Menu " , Black);
       window2.RenderText( Position(13.0,8.0) , Position(17.0,9.0) , " 3)Display Menu  " , Black);
       window2.RenderText( Position(13.0,10.0) , Position(17.0,11.0) , "4) Exit  " , Black);
       window2.RenderText( Position(9.0,12.0) , Position(21.0,14.0) , "Switch to terminal for input  " , Red);
       cin>>input_variable;
       switch(input_variable)
        {
              case 1:
                             window2.Close();
                             student_processing_menu();    //defined on line number 256
                             break;
             case 2:
                             window2.Close();
                             result_processing_menu();         //defined on line number 297
                             break;
             case 3:
                            window2.Close();
                             display_menu();        //defined on line number 330
                             break;
              case 4:
                             window2.Close();
                             return;
             default:  cout<<"   WRONG Input.....\n";
         }
     }while(input_variable!=4);

}

///////////////////////////////////////////////////////////////////////////////////////////////


void student_processing_menu()
{  /* Menu to show the submenu pertaining to the options regarding changes in student file
      like entry of new student , modification of details, or deletion of student data.
      Inputs choice in a variable and calls function accordingly.
   */
  SimpleWindow window3("STUDENT PROCESSING MENU", 30.0 , 15.0, Position(0.0,0.0));
   do
    {
       window3.Open();
       window3.RenderText( Position(12.0,2.0) , Position(18.0,3.0) , "Student Processing Menu  " , Black);
       window3.RenderText( Position(13.0,4.0) , Position(17.0,5.0) , "1) Entry of new student  " , Black);
       window3.RenderText( Position(13.0,6.0) , Position(17.0,7.0) , "2) Modification of details " , Black);
       window3.RenderText( Position(13.0,8.0) , Position(17.0,9.0) , " 3)Deletion of record of student " , Black);

       window3.RenderText( Position(13.0,10.0) , Position(17.0,11.0) , "4) Exit  " , Black);
       window3.RenderText( Position(9.0,12.0) , Position(21.0,14.0) , "Switch to terminal for input  " , Red);
       cin>>input_variable;
       switch(input_variable)
        {
              case 1:
                             window3.Close();
                             entry_newstud();         //defined on line number 473
                             break;
             case 2:
                             window3.Close();
                             modification_stud();         //defined on line number 1687
                             break;
             case 3:
                            window3.Close();
                             deletion_stud();         //defined on line number 1567
                             break;
              case 4:
                             window3.Close();
                             return;
             default:  cout<<"   WRONG Input.....\n";
         }
     }while(input_variable!=4);

}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void result_processing_menu()
{ /*Menu to show the options regarding modifications of marks
    Takes input in variable and calls function accordingly*/
 
  SimpleWindow window4("RESULT PROCESSING MENU", 30.0 , 15.0, Position(0.0,0.0));
   do
    {
       window4.Open();
       window4.RenderText( Position(12.0,2.0) , Position(18.0,3.0) , "Student Processing Menu  " , Black);
       
       window4.RenderText( Position(13.0,6.0) , Position(17.0,7.0) , "1) Modification of marks " , Black);
       window4.RenderText( Position(13.0,8.0) , Position(17.0,9.0) , " 2)Exit " , Black);
 
       window4.RenderText( Position(9.0,12.0) , Position(21.0,14.0) , "Switch to terminal for input  " , Red);
       cin>>input_variable;
       switch(input_variable)
        {
              
             case 1:
                             window4.Close();
                             modification_marks();         //defined on line number 1487
                             break;
             
              case 2:
                             window4.Close();
                             return;
             default:  cout<<"   WRONG Input.....\n";
         }
     }while(input_variable!=2);

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void display_menu()
{ /*As suggested by the name It gives adminstrator the options of display of student file , course file , marksheet
    of a student and various queries that are regular regarding student's database   */  
  char ch;  //For input of subchoice in Queries portion
  SimpleWindow window6("Display Menu",30.0,15.0, Position(0.0,0.0));
     do
     {
       window6.Open();
       window6.RenderText( Position(12.0,0.0) , Position(18.0,1.0) , "Administrator Display Menu  " , Black);
       window6.RenderText( Position(9.0,2.0) , Position(13.0,3.0) , "1) Student file display  " , Black);
       window6.RenderText( Position(9.0,3.0) , Position(13.0,4.0) , "2) Course file display  " , Black);
       window6.RenderText( Position(9.0,4.0) , Position(13.0,5.0) , "3) Marksheet Display  " , Black);
       window6.RenderText( Position(9.0,5.0) , Position(13.0,6.0) , "4) Queries  " , Black);
       window6.RenderText( Position(11.0,6.0) , Position(21.0,7.0) , "a) Hostel wise Department strngth  " , Black);
       window6.RenderText( Position(11.0,7.0) , Position(21.0,8.0) , "b) Hostel wise State strngth " , Black);
       window6.RenderText( Position(11.0,8.0) , Position(21.0,9.0) , "c) count of NSS/NSO/NCC stud  " , Black);
       window6.RenderText( Position(11.0,9.0) , Position(21.0,10.0) , "d)Blood group wise student count  " , Black);
       window6.RenderText( Position(11.0,10.0) , Position(21.0,11.0) , "e)Division wise instructor list " , Black);
       window6.RenderText( Position(11.0,11.0) , Position(21.0,12.0) , "f)Highest marks course and division wise  " , Black);  
        window6.RenderText( Position(9.0,12.0) , Position(13.0,13.0) , "5) Exit  " , Black);
       window6.RenderText( Position(11.0,13.0) , Position(21.0,14.0) , "If choosing queries then mention after space the suboption  " , Black);
         cin>>input_variable;
       switch(input_variable)
        {
             case 1:
                             window6.Close();
                             student_file_display();         //defined on line number 1207
                             break; 
             case 2:
                             window6.Close();
                             course_file_display1();         //defined on line number 1283
                             break;
             case 3:
                             window6.Close();
                             Marksheet1();         //defined on line number 1375
                             break;
             case 4:
                            window6.Close();
                             cin>>ch;
                             switch(ch)
                               {
                                   case 'a': window6.Close();
                                             query1();         //defined on line number 753
                                              break;
                                   case 'b':  window6.Close();
                                             query2();         //defined on line number 867
                                              break;
                                   case 'c':   window6.Close();
                                             query3();         //defined on line number 976
                                              break;                          
                                   case 'd':  window6.Close();
                                             query4();         //defined on line number 1001
                                              break;
                                   case 'e': window6.Close();
                                             query5();         //defined on line number 1070
                                              break;
                                   case 'f': window6.Close();
                                             query6();         //defined on line number 1160
                                              break;
                                   default: cout<<" Wrong input....";
                               }//end of inner switch 
                                    break;
              case 5:
                             window6.Close();
                             return;
             default:  cout<<"   WRONG Input.....\n";
         }//end of outer switch
     }while(input_variable!=5);//end of do while

}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void studentmenu(student_info &var1)
{    /*Menu for a student user.
       Parameter of student_info variable has been used in the code
       Takes input about his/her choice and calls function accordingly*/ 
     char ch;//For input of subchoice in Queries
     char c[40]="Menu For ";
     strcat(c,var1.name);
     SimpleWindow window5(c,30.0,15.0, Position(0.0,0.0));
     do
     {
       window5.Open();
       window5.RenderText( Position(12.0,1.0) , Position(18.0,2.0) , "Student Display Menu  " , Black);
       window5.RenderText( Position(9.0,3.0) , Position(13.0,4.0) , "1) Course file display  " , Black);
       window5.RenderText( Position(9.0,4.0) , Position(13.0,5.0) , "2) Marksheet Display  " , Black);
       window5.RenderText( Position(9.0,5.0) , Position(13.0,6.0) , "3) Queries  " , Black);
       window5.RenderText( Position(11.0,6.0) , Position(21.0,7.0) , "a) Hostel wise Department strngth  " , Black);
       window5.RenderText( Position(11.0,7.0) , Position(21.0,8.0) , "b) Hostel wise State strngth " , Black);
       window5.RenderText( Position(11.0,8.0) , Position(21.0,9.0) , "c) count of NSS/NSO/Ncc stud  " , Black);
       window5.RenderText( Position(11.0,9.0) , Position(21.0,10.0) , "d)Blood group wise student count  " , Black);
       window5.RenderText( Position(11.0,10.0) , Position(21.0,11.0) , "e)Division wise instructor list " , Black);
       window5.RenderText( Position(11.0,11.0) , Position(21.0,12.0) , "f)Highest marks course and division wise  " , Black);  
       window5.RenderText( Position(9.0,12.0) , Position(13.0,13.0) , "4) Exit  " , Black);
       window5.RenderText( Position(11.0,13.0) , Position(21.0,14.0) , "If choosing queries then mention after space the suboption  " , Black);
       window5.RenderText( Position(9.0,5.0) , Position(13.0,6.0) , "3) Queries  " , Black);
       cin>>input_variable;
       switch(input_variable)
        {
              case 1:
                             window5.Close();
                             course_file_display2(var1);         //defined on line number 1457
                             break;
             case 2:
                             window5.Close();
                             Marksheet2(var1);         //defined on line number 1401
                             break;
             case 3:
                            
                             cin>>ch;
                             switch(ch)
                               {
                                   case 'a': window5.Close();
                                             query1();         //defined on line number 753
                                              break;
                                   case 'b':  window5.Close();
                                             query2();         //defined on line number 867
                                              break;
                                   case 'c':   window5.Close();
                                             query3();         //defined on line number 976
                                              break;                          
                                   case 'd':  window5.Close(); 
                                             query4();         //defined on line number 1001
                                              break;
                                   case 'e': window5.Close(); 
                                             query5();         //defined on line number 1070
                                              break;
                                   case 'f': window5.Close();
                                             query6();         //defined on line number 1160
                                              break;
                                   default: cout<<" Wrong input....";
                               } 
                                    break;
              case 4:
                             window5.Close();
                             return;
             default:  cout<<"   WRONG Input.....\n";
         }
     }while(input_variable!=4);

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void entry_newstud()
{   /*  Function to ask for the entry of the new student to the database.
        Involces all the files to open up and close accordingly
        Asks for each of the details and 
       checks for its validity in a list of functions meant for each data.
        Takes input at each stage....
       Outputs that the entry is wrong if that doesnt match with the presumption of ours.
       
    */
     Pstudent=fopen("student.abc","ab");
     Pindex=fopen("index.abc","ab+");
     Presult=fopen("result.abc","ab");
     cout<<"\n\n\t Enter roll number of the student:-\t";
     cin>>student.roll_no;
    if(check_roll_no(student.roll_no)==0)
     {
           cout<<"\n\n\t\tInvalid roll number";
           return;
     }    

     get_student_info();         //defined on line number 735
     /*After the input it opens the respective files and write the data onto them.
       It even opens result file and puts default data of 0 marks unless entered
       again using the modification marks function
      */
     fseek(Pstudent,0,SEEK_END);
     fwrite(&student,sizeof(student),1,Pstudent);
     fclose(Pstudent);

     strcpy(index1.roll_no,student.roll_no);
     fseek(Pindex,0,SEEK_END);
     index1.record= (int)ftell(Pindex)/sizeof(index1) +1;
     fwrite(&index1,sizeof(index1),1,Pindex);
     fclose(Pindex);

     initialize_result();         //defined on line number 525
     fseek(Presult,0,SEEK_END);
     fwrite(&result,sizeof(result),1,Presult);
     fclose(Presult);   
}
/////////////////////////////////////////////////////////////////////////////////////////////////
   
  void con_toupper(char str[])
  { //Converts the string all in its upper case
    //Takes string as parameter 
    int a;
    for(a=0;str[a]!='\0';a++)
         if(str[a]>='a'&&str[a]<='z')
                str[a]=toupper(str[a]);//toupper function defined in ctype is meant to convert each character to its uppercase
  }

///////////////////////////////////////////////////////////////////////////////////////
 void initialize_result()
  {  /*Function to initialize default data in result variable
      Logically when data for new student is entered then its corresponding data should come up
      in result and index file even . So it does that*/
     int a;
     strcpy(result.roll_no,student.roll_no);
     for(a=0;a<6;a++)
          result.marks[a]=0;
     strcpy(result.extra_act,"-");
     result.SPI=0.0;
   }

//////////////////////////////////////////////////////////////////////////////////////
  int check_roll(char roll[])
   {  //checks whether the passed parameter of roll number is present in index file or not
      //if yes returns 0 otherwise 1
           rewind(Pindex);
     while(fread(&index1,sizeof(index1),1,Pindex)!=0)
              if(strcmp(roll,index1.roll_no)==0)
                     return 0;
     return 1;
    }
///////////////////////////////////////////////////////////////////////////////////////////
  void get_name(char std_Name[])
   {  //Takes the input of the name and converts it to uppercase by calling con_toupper
      cout<<"\n\n\t\t Enter name of the student:-\t";
      fflush(stdin);                 //meant to clear the stack of stdin file
      cin>>std_Name;
      con_toupper(std_Name); 
      return;
    }
////////////////////////////////////////////////////////////////////////////////////////////////
         void get_dob(struct DOB &dob)
   { //Function taking input of date of birth and checking its validity
     int month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
     int check;
     do{
           check=1;
           cout<<"\n\tEnter the date of birth\n\n\tDATE (Just the date in integer form not month or year) :-    ";
           cin>>dob.date;
           cout<<"\n\tMONTH (enter month in Integer form )(Use 9 & 8 for sep and aug not 09 & 08):-  ";
           cin>>dob.month;
           cout<<"\n\t\tYEAR (integer form):-   ";
           cin>>dob.year;
           if(dob.date<1||dob.date>31)
                check=0;
           if(dob.month<1||dob.month>12)
                check=0;
           else
           {
                  if(dob.date>month[dob.month-1])
                  {             
                      check=0;
                      if(dob.month==2 && dob.year%4==0 && dob.date==29)
                             check=1; 
                  }
           } 
           if(check==0)
                  cout<<"\n\n\t\tInvalid date, enter valid date...";  
     }while(check==0);
     return;
    }

///////////////////////////////////////////////////////////////////////////////
         void get_division(short int &div)
    {  //Asks for division and checks its validity
            do
              {  
               cout<<"\n\tEnter the division of the student(1-5)  -  D";
               cin >>div;
               if(div<1||div>4)
               {
                   cout<<"\n\n\tInvalid division entered. Enter a valid division(1-4)";
               }
             }while(div<1||div>4);
     
     return;
    }
//////////////////////////////////////////////////////////////////////////////////////
          int check_roll_no(char roll_no[])
    { //Function to check for validity of roll number.
      //Presumption is that first 2 digits are 10. next is either D or d or 0-9. others can be any other
      //Also it should be 9 characters long
      int n;
      if(strlen(roll_no)!=9)
            return 0;
      else {
            }   
      if(roll_no[0]!='1'||roll_no[1]!='0') 
            return 0;
      else{
            }
      if(roll_no[2]!='0'&&roll_no[2]!='D'&&roll_no[2]!='d')
            return 0;   
      else{
            }
      for(n=3;n<9;n++)
           if(roll_no[n]>'9'||roll_no[n]<'0')
                    return 0;
           else{
                }
      if(check_roll(roll_no))
           return 1; 
      else {
            }
      return 0;

     }
//////////////////////////////////////////////////////////////////////////
         void get_hostel(struct student_info &std)
  {//Function to take input of hostel number and room number and check its validity
      int check;
      do
      {
        check=1;
        cout<<"\n\n\t\tEnter hostel number        ";
        cin>>std.hostel_no;
        if(std.hostel_no<1||std.hostel_no>4)
          {
             cout<<"\n\tInvalid hostel number. Enter valid hostel number(1-4)";
             check=0;
          }
       }while(check==0);

      do
     {
        check=1;
        cout<<"\n\n\t\tEnter room number          ";
        cin>>std.room_no;
        if(std.room_no<1||std.room_no>450)
        {
             cout<<"\n\tInvalid room number. Enter valid room number(1-450)";
             check=0;
        }
      }while(check==0);
     return;
  }

///////////////////////////////////////////////////////////////////////////////////////////
         void get_extra(char str[])
    {//takes input of extra activity and checks for its correctness
     int check;
     do
     { 
         check=1; 
         cout<<"\n\n\t\tEnter the extra activity(NSO/NSS/NCC) :-     ";
         cin>>str;
         con_toupper(str);
         if(strcmp(str,"NSS")!=0&&strcmp(str,"NCC")!=0&&strcmp(str,"NSO")!=0)
         {
                check=0;
                cout<<"\n\n\t\t Invalid entry. Enter again....";
         }
     }while(check==0);
     return;
    }
///////////////////////////////////////////////////////////////////////////////////////
 void get_state(char str[])
    {           //takes input of student's home state
      cout<<"\n\n\t\tEnter Home state :-    ";
      fflush(stdin);
      cin>>str;
      con_toupper(str);
    }
//////////////////////////////////////////////////////////////////////////////////////////
           void get_blood_group(char blood_group[])
    { //Function to get input of blood group and check its validity
         int check;
        do
        {
              check=1; 
              cout<<"\n\n\t\tEnter blood group:-         ";
              cin>>blood_group;
              con_toupper(blood_group);
              if(strcmp(blood_group,"A-")!=0&&strcmp(blood_group,"B-")!=0&&strcmp(blood_group,"AB-")!=0&&strcmp(blood_group,"O-")!=0&&strcmp(blood_group,"B+")!=0&&strcmp(blood_group,"AB+")!=0&&strcmp(blood_group,"O+")!=0&&strcmp(blood_group,"A+")!=0)
               {
                      check=0;
                      cout<<"\n\tInvalid blood group entered. Enter valid blood group(ex.  A+,A- etc. )   ";
               }
        }while(check==0); 
        return;
   } 
////////////////////////////////////////////////////////////////////////////////////
       void get_password(char password[])
   { //function to ask for input of password and its reentry. Matches them to save them
     int check;
     char temp[22];
     do
     {
          check=1; 
          cout<<"\n\n\t\tEnter password:-         "; 
          cin>>password;
          cout<<"\n\t\tReenter password:-         "; 
          cin>>temp;
          if(strcmp(temp,password)!=0)
          {
                 check=0;
                 cout<<"\n\n\t\tPassword reentered do not match!!!!";
          }
      }while(check==0);
    }
//////////////////////////////////////////////////////////////////////////////////////////////
     void get_branch(char branch[])
    {   //inputs branch in parameter passed
        cout<<"\n\n\t\tEnter Branch:-        ";
        cin>>branch;
                                
            
    }
////////////////////////////////////////////////////////////////////////////////////////
     void get_student_info()
    {// Function to call all the subfunctions of input
      get_name(student.name);         //defined on line number 548
      get_division(student.division);           //defined on line number 589
      get_dob(student.dob);         //defined on line number 557
      get_hostel(student);         //defined on line number 634
      get_extra(student.extra_act);         //defined on line number 664
      get_state(student.home_state);         //defined on line number 682
      get_blood_group(student.blood_group);         //defined on line number 690
      get_password(student.password);         //defined on line number 708
      get_branch(student.branch);         //defined on line number 727
    }
     
      


///////////////////////////////////////////////////////////////////////////////////////////////////////

void query1()
{
  /*function is meant to handle query of display of Hostel wise State strength.
    It takes a no input rather outputs the display in a tabular format on the terminal screen*/
   int i,j,coloumn,row;
   coloumn=0;
   row=0;
   int deptdata[6][5];//To hold the count of number of students in each state in each hostel
     for(i=0; i<6; i++) 
       {
          for(j=0; j<5; j++)
             { 
                deptdata[i][j]=0; //initialize with 0 to all
              } 
       }
            
      Pstudent=fopen("student.abc","rb");           
      if(Pstudent==NULL) 
            cout<<"error opening the file!";

            
            //row and column values are adjusted according to state and hostel of student. And corresponding variable of statedata is incremented 
      while(!feof(Pstudent)) 
         {
            fread(&student,sizeof( student_info),1,Pstudent);            
            if(!strcmp(student.branch, "Computer Science"))
            row=0;
            else if(!strcmp(student.branch, "Electrical"))
            row=1;
            else if (!strcmp(student.branch, "Mechanical"))
            row=2;
            else if(!strcmp(student.branch, "Chemical"))
            row=3;
            else if(!strcmp(student.branch, "Civil"))
            row=4;
            else
            row=5; 

            if(student.hostel_no==1)
            coloumn=0;
            else if(student.hostel_no==2)
            coloumn=1;
            else if(student.hostel_no==3)
            coloumn=2;
            else if(student.hostel_no==4)
            coloumn=3;
            else if(student.hostel_no==10)
            coloumn=4;
            else
            cout<<"The hostel number should be  1,2,3,4 or 10"<<endl;
            
            deptdata[row][coloumn]++;
         }
           

      fclose(Pstudent);
       //Displaying in tabular format

       cout<<"Hostel Number     1     2     3     4     10"<<endl;
          cout<<""<<endl;
          cout<<""<<endl;

        cout<<"Computer Science ";
           for(i=0;i<5;i++)
             {
              cout<<" "<<deptdata[0][i]<<"    ";
             }
        cout<<""<<endl;
        cout<<""<<endl;

         cout<<"Electrical       ";
            for(i=0;i<5;i++)
              {
                 cout<<" "<<deptdata[1][i]<<"    ";
              }
         cout<<""<<endl;
         cout<<""<<endl;

         cout<<"Mechanical       ";
            for(i=0;i<5;i++)
             {
                cout<<" "<<deptdata[2][i]<<"    ";
             }
         cout<<""<<endl;
         cout<<""<<endl;

         cout<<"Chemical         ";
            for(i=0;i<5;i++)
             {
               cout<<" "<<deptdata[3][i]<<"    ";
             }
          cout<<""<<endl;
          cout<<""<<endl;
 
          cout<<"Civil            ";
             for(i=0;i<5;i++)
              {
               cout<<" "<<deptdata[4][i]<<"    ";
              }
          cout<<""<<endl;
          cout<<""<<endl;

          cout<<"Others           ";
             for(i=0;i<5;i++)
              {
               cout<<" "<<deptdata[5][i]<<"    ";
              }
          cout<<""<<endl;


}   //end of function         
    
////////////////////////////////////////////////////////////////////////////////////////////////////

void query2()
{
  /*function is meant to handle query of display of Hostel wise Department strength.
    It takes a no input rather outputs the display in a tabular format on the terminal screen*/
            int i,j,coloumn,row,a,n;
            
            
            coloumn=0;
            row=0;
            int statedata[6][5];//To hold the count of number of students in each branch in each hostel
            for(i=0; i<6; i++) 
               {
                  for(j=0; j<5; j++)
                    { 
                         statedata[i][j]=0; 
                    }
               }
            Pstudent=fopen("student.abc","rb");
            if(Pstudent==NULL) cout<<"error";
            fread(&student,sizeof(student_info),1,Pstudent);
   //row and column values are adjusted according to dept and hostel of student. And corresponding variable of deptdata is incremented 
         while(!feof(Pstudent)) 
           {
                
               

                if(student.home_state[0]=='m')
                   { row=0;}                                                                                                                                            
                else if(student.home_state[0]=='U')
                     { row=1;}
                else if(student.home_state[0]=='M')
                     { row=2;}
                else if(student.home_state[0]=='A')
                      { row=3;}
                else if(student.home_state[0]=='r')
                      { row=4;}
                  else
                      { row=5;} 

                   a=student.hostel_no;

                   if(a==1){
 
                     coloumn=0;}
                   else if(a==2){
                     coloumn=1;}
                  else if(a==3){
                    coloumn=2;}
                  else if(a==4){
                     coloumn=3;}
                  else if(a==10){
                    coloumn=4;}
                   else{
                         cout<<"the hostel number should be  1,2,3,4 or 10"<<endl;
                        }
 
                 statedata[row][coloumn]++;
                 fread(&student,sizeof(student_info),1,Pstudent);

             }//end of while loop
    fclose(Pstudent);
                     //Display in tabular form
    cout<<"hostel number   1     2     3     4     10"<<endl;
   cout<<""<<endl;
   cout<<""<<endl;
   cout<<"maharashtra    ";
   for(i=0;i<5;i++)
    {
      cout<<" "<<statedata[0][i]<<"    ";
    }
     cout<<""<<endl;
     cout<<""<<endl;
    cout<<"UP             ";
    for(i=0;i<5;i++){
         cout<<" "<<statedata[1][i]<<"    ";
                    }
     cout<<""<<endl;
     cout<<""<<endl;
     cout<<"MP             ";
     for(i=0;i<5;i++)
     {
     cout<<" "<<statedata[2][i]<<"    ";
     }
     cout<<""<<endl;
     cout<<""<<endl;
     cout<<"AP             ";
    for(i=0;i<5;i++)
     {
      cout<<" "<<statedata[3][i]<<"    ";
     }
    cout<<""<<endl;
    cout<<""<<endl;
    cout<<"rajasthan      ";
     for(i=0;i<5;i++)
      {
         cout<<" "<<statedata[4][i]<<"    ";
      }
     cout<<""<<endl;
      cout<<""<<endl;
     cout<<"others         ";
     for(i=0;i<5;i++)
      {
       cout<<" "<<statedata[5][i]<<"    ";
       }
      cout<<""<<endl;

} 

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
 void query3()
{
    char Number[3][4]={"NCC","NSO","NSS"};     // Declaring & initialising the 2-D character array "Number[3][4]" which will be used for further comparison.  
   int ncc,nss,nso, compare1 , compare2 , compare3 ;       // Declaring more variables all "int" type.
   ncc=nss=nso=0;   
   Pstudent=fopen("student.abc","rb");        // Linking binary file "studentfile" in Reading mode to file pointer "Pstudent".
   while(!feof(Pstudent))                     // Contitional expression of loop upto the end of the file. At the end condition becomes false. 
     {
                                    //Extracting data of one student from binary file "studentfile" in its "student_info",structure type variable "student".       
        fread(&student, sizeof(student) , 1 , Pstudent );                   
        compare1=strcmp(student.extra_act,Number[0]);     // Comparing "extra_act" of student with "NCC".       
          (compare1==0)?ncc++:ncc;                    // This conditional expression will accordingly increase the count "ncc" based on value of "compare1".           
        compare2=strcmp(student.extra_act,Number[1]);     // Comparing "extra_act" of student with "NSO".         
          (compare2==0)?nso++:nso;                    // This conditional expression will accordingly increase the count "nso" based on value of "compare2".        
        compare3=strcmp(student.extra_act,Number[2]);     // Comparing "extra_act" of student with "NSS".        
          (compare3==0)?nss++:nss;                    // This conditional expression will accordingly increase the count "nss" based on value of "compare3".   
     }    
    cout<<"The number of students in 'N.C.C' are = "<<ncc<<endl;     // Printing the number of students in "N.C.C".   
    cout<<"The number of students in 'N.S.O' are = "<<nso<<endl;     // Printing the number of students in "N.S.O".   
    cout<<"The number of students in 'N.S.S' are = "<<nss<<endl;     // Printing the number of students in "N.S.S".
 return;                                                              // Returning nothing as return type of the function is "void" .

}

//////////////////////////////////////////////////////////////////////////////////////
void query4()
{
  /*    Roll number:100040094
      Name: B. Hemanth Kumar

        PROGRAM
        
        Blood groupwise student count
        
        INPUT
        
        The user chooses the subheader 'blood group wise student count' in the menu under queries.    
        OUTPUT
         The output is the number of students belonging to a particular blood group.  
      // Definition of function with no arguments

      /*   I wish to make two arrays. one of them is a two dimensional string array and the other is an integer array.              
             
           The dimensions of the string array is 8*5. 
           I feed or initialize the array row wise by the eight different  blood groups.
            
           The other array is an integer array containing 8 elements corresponding to the number of students.
           The values are initialized to zero in this array

           I want to estabilish  a one to one correspondence between the array of strings and array of integers.
           The first row of the multidimensional string which contains a blood group corresponds to the number of students with that blood group .*/
            int bloodgroup_count[8]={0,0,0,0,0,0,0,0};
       
       char blood_group[8][6]={"A+ve","A-ve" ,"B+ve","B-ve","AB+ve","AB-ve","O+ve","O-ve"};
      /*.Now i create a file pointer named Pstudent. 
         I open the binary file of student data pointing the pointer to it with 'fopen' statement.
         I set the internal pos variable to the initial position with the help of 'fseek' statement.*/


       int filepos=0,i=0;

       Pstudent=fopen("student.abc","rb");
              
       fseek(Pstudent,filepos,SEEK_SET);
        while(!feof(Pstudent))
           {
             /* Copying the first record in to a structure variable named sample.
                
                The length of the structure is known by'sizeof' function  */
               fread(&student,sizeof(student_info),1,Pstudent);
           /* Setting up a loop in order to find out to which bloodgroup the student in this record belongs to.*/
              for(i=0;i<8;i++)
                    {
                      if  (strcmp(student.blood_group,blood_group[i]) ==0)
                           bloodgroup_count[i]=bloodgroup_count[i]+1;

                     /* As and when the bloodgroup of the sample matches with one of the bloodgroups of the two dimensional 
                        string array i increment the value of the corresponding element in the integer array bloodgroup_count. */

                    }
             }

         cout<<"The blood group wise student count is"<<endl;
            //Printing data
         for(i=0;i<8;i++)
              {
                cout<<blood_group[i]<<":"<<bloodgroup_count[i]<<endl;                                            
             }
        return;

}
           
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void query5()
{
 /*    Roll number:100040094
      Name: B. Hemanth Kumar
PROGRAM
Divison wise instructor info
INPUT
Divison to which the student belongs.
OUTPUT
The courses for which he or she has been registered and the instructors
in charge.
It takes the input of division and reads course file according to it and displays line by line
               
                                      */
//Definition of function with no arguments.
 

 int divison,filepos=0,i=0;
 
 FILE *Pcourse;

 Pcourse=fopen("course.abc","rb");

 fseek(Pcourse,filepos,SEEK_SET);

 cout<<"Give the divison for which the details are required"<<endl;
 
 cin>>divison;
 switch(divison){
      case 1:
                  fseek(Pcourse,filepos,SEEK_SET);
                  fread(&course,sizeof(course),1,Pcourse);
                  for(i=1;i<=6;i++)
                     { 
                       cout<<course.subject[i].course_name<<endl;           
                       cout<<course.subject[i].instructor_name<<endl;
                       cout<<course.subject[i].credits<<endl;          
                       cout<<endl;        
                      }
                   break;

      case 2:
   
                   filepos=sizeof(course);
                   fseek(Pcourse,filepos,SEEK_SET);
                   fread(&course,sizeof(course),1,Pcourse);
                   for(i=1;i<=6;i++)
                       {          
                          cout<<course.subject[i].course_name<<endl;             
                          cout<<course.subject[i].instructor_name<<endl;
                          cout<<course.subject[i].credits<<endl;         
                          cout<<endl;       
                       }
                    break;



       case 3:
    
                    filepos=2*sizeof(course);
                    fseek(Pcourse,filepos,SEEK_SET);
                    fread(&course,sizeof(course),1,Pcourse);
                     for(i=1;i<=6;i++)
                        {
                          cout<<course.subject[i].course_name<<endl;           
                          cout<<course.subject[i].instructor_name<<endl;
                          cout<<course.subject[i].credits<<endl;         
                          cout<<endl;        
                        }
                     break;


       case 4:
                  filepos=3*sizeof(course);
                  fseek(Pcourse,filepos,SEEK_SET);
                  fread(&course,sizeof(course),1,Pcourse);
                  for(i=1;i<=6;i++)
                       { cout<<course.subject[i].course_name<<endl;             
                         cout<<course.subject[i].instructor_name<<endl;
                         cout<<course.subject[i].credits<<endl ;         
                         cout<<endl;        
                       }
                  break;
              }//end of switch
    fclose(Pcourse);      
    return ;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void query6()
{
   int userdivision;  //defining the various variables 
   char usercourse[6];
   int t,j,i,maxmarks;
   cout<<"for which division and which course do you want know the highest marks"<<endl;
   cin>>userdivision;    // taking input from user
   cin>>usercourse;                    
   Pcourse=fopen("course.abc","rb"); // opening course file	
   fread(&course,sizeof(course),1.0,Pcourse); 
   if(course.division==userdivision) // checking the userdivision       
   for(i=0;i<6;i++)               
   if(strcmp(course.subject[i].course_name,usercourse)==0)
       {
          t=i;
       } //comparing usercourse and storing its position in t
   else 
         cout<<"this course is not registered for this   division"<<endl;            
   fclose(Pcourse); // closing the file

   Pstudent=fopen("student.abc","rb");
   fread(&student,sizeof(student),1.0,Pstudent);
   j++;

   Presult=fopen("result.abc","rb");
   if(student.division==userdivision)
      {      
            fseek(Presult,(j-1)*sizeof(result),0); // seeking the position of the 
            maxmarks=-1;                     // student present in that div.
            if(result.marks[t]>maxmarks)
              {      //comparing the marks of each 
                 maxmarks=result.marks[t]; // student in that div. & storing 
              }                       // highest marks in maxmarks
      }



    cout<<"topper of division "<<userdivision<<" is "<<student.name<<" whose roll no, is "<<student.roll_no<<" and the highest marks in "<<usercourse<<" are     "<<maxmarks<<endl;

   fclose(Pstudent);   // display name,rollno.,marks of topper
   fclose(Presult);


} 

///////////////////////////////////////////////////////////////////////////////////////////////

void student_file_display()
{     
                // Create a window with title "untitled", size 23.5cm x 17.0cm,
                //     positioned 3cm from left, 1cm from top of screen.
   SimpleWindow MyWindow("Student File", 26.85, 17.0,
		      Position(3.0, 1.0));
             // ApiMain(): create a window and display some shapes
    MyWindow.Open();
                   // assert:check the status of the window.
    assert(MyWindow.GetStatus() == WindowOpen);
                   // Colors: {White, Red, Green, Blue, Yellow, Cyan, Magenta};
                    //White Rectangle, with border
    MyWindow.RenderRectangle(Position(0.3,0.3), Position(26.4,16.7),
			   White, true);
                   //Red Line, thickness 0.1 cm.
    MyWindow.RenderLine(Position(0.35,1.3),Position(26.35,1.3),
		      Red,0.1);
                 //Red Line, thickness 0
   MyWindow.RenderLine(Position(6.3,0.3),Position(6.3,16.7),
		      Red,0.0);
  for(int j=0;j<6;j++)
    {
     MyWindow.RenderLine(Position(6.3+(3.35*j),0.3),Position(6.3+(3.35*j),16.7),
                      Red,0.0);
    }

  for(int i=0;i<30;i++)
    {
     MyWindow.RenderLine(Position(0.3,1.813+(0.513*i)),Position(26.4,1.813+(0.513*i)),
                      Red,0.0);
    }
  //Display the text
  MyWindow.RenderText(Position(0.3,0.3),Position(6.3,1.3),"NAME",Blue);
  MyWindow.RenderText(Position(6.3,0.3),Position(9.65,1.3), "ROLL NO.",Blue);
  MyWindow.RenderText(Position(9.65,0.3),Position(13.0,1.3),"BLOOD GROUP",Blue);
  MyWindow.RenderText(Position(13.0,0.3),Position(16.35,1.3), "DIVISION",Blue);
  MyWindow.RenderText(Position(16.35,0.3),Position(19.7,1.3),"HOME STATE",Blue);
  MyWindow.RenderText(Position(19.7,0.3),Position(23.05,1.3),"BRANCH",Blue);
  MyWindow.RenderText(Position(23.05,0.3),Position(26.4,1.3), "EXTRA ACTIVITY",Blue); 
    int i;
    int recsize;
    recsize=sizeof(struct student_info);   
    Pstudent= fopen("student.abc","rb");     
    fseek(Pstudent,0,2);
    int a=ftell(Pstudent)/sizeof(student);    //to know about the number of records in file
    rewind(Pstudent);
      for(i=0;i<a;i++)
      {		
	       fread(&student,recsize,1,Pstudent);     // reading data from student file
              char ch=char(student.division+48);
              char d[3]={'D',ch,'\0'};
	 //displaying the text after reading from the file        	
	 MyWindow.RenderText(Position(0.3,1.3+(0.513*i)),Position(6.3,1.813+(0.513*i)),
                         student.name,Black);        
         MyWindow.RenderText(Position(6.3,1.3+(0.513*i)),Position(9.65,1.813+(0.513*i)),
                         student.roll_no,Black);
         MyWindow.RenderText(Position(9.65,1.3+(0.513*i)),Position(13.0,1.813+(0.513*i)),
                         student.blood_group,Black);
         MyWindow.RenderText(Position(13.0,1.3+(0.513*i)),Position(16.35,1.813+(0.513*i)),
                           d,Black);
         MyWindow.RenderText(Position(16.35,1.3+(0.513*i)),Position(19.7,1.813+(0.513*i)),
                         student.home_state,Black);
         MyWindow.RenderText(Position(19.7,1.3+(0.513*i)),Position(23.05,1.813+(0.513*i)),
                         student.branch,Black);
         MyWindow.RenderText(Position(23.05,1.3+(0.513*i)),Position(26.4,1.813+(0.513*i)),
                         student.extra_act,Black);         
      }
          char c;
          cin>>c;
	fclose(Pstudent);
 MyWindow.Close();
 return ;
} 

///////////////////////////////////////////////////////////////////////////////////////////////////////////////

void course_file_display1()
{ //Function to display the course file contents in a TABULAR form on EZWiNDOWS....
  SimpleWindow MyWindow("COURSE  FILE ", 29.0, 17.0,
		      Position(0.0, 0.0));
 
  MyWindow.Open();
  assert(MyWindow.GetStatus() == WindowOpen);
                                                                   //White rectangle , with  border
  MyWindow.RenderRectangle(Position(0.0,0.0), Position(29.0,17.0),
			   White, true);
                                                                   //Drawing lines for making table
        for(float i=2;i<=16;i+=3.75)
           {
           MyWindow.RenderLine(Position(0.0,i),Position(29,i),
		      Red,0.0);
           }  
        for(float i=2;i<=15.75;i+=1.25)
           {
           MyWindow.RenderLine(Position(2,i),Position(29,i),
		      Blue,0.0);

           }
        for(float i=6.5;i<27;i+=4)
           {
           MyWindow.RenderLine(Position(i,2),Position(i,17.0),
		      Black,0.0);
            }
           MyWindow.RenderLine(Position(2,0),Position(2,17.0),
		      Green,0.0);
///////////// Display the text(headings)
	   MyWindow.RenderText(Position(0.0,0.0), Position(2.0,2.0),
	               "Division", Blue);

           MyWindow.RenderText(Position(2.0,0.0), Position(29.0,2.0),
	               "Courses", Blue);

         for(float j=2;j<=13.25;j+=3.75)//Loop for displaying data in different position
          {
           MyWindow.RenderText(Position(2.0,j), Position(6.5,j+1.25),
	                "Course name", Red);

           MyWindow.RenderText(Position(2.0,j+1.25), Position(6.5,j+2.5),
	                "Instructor name", Red);

           MyWindow.RenderText(Position(2.0,j+2.5), Position(6.5,j+3.75),
	                "Credits", Red);

          }

        float i=0.0;
        Pcourse= fopen("course.abc","rb");
    while(!feof( Pcourse))
    {   //Reading course file and displayind data at requisite places
        fread(&course,sizeof(course),1.0, Pcourse);
                
               char ch=char(course.division+48);
               char d[3]={'D',ch,'\0'};
                
                char b;
             
              MyWindow.RenderText(Position(0.0,2+i), Position(2,5.75+i),
                             d, Green);
              
             for(int j=0;j<6;j++)
             {
               MyWindow.RenderText(Position(6.5+(4*j),2+i), Position(10.5+(4*j),3.25+i),
	                      course.subject[j].course_name, Red);

               MyWindow.RenderText(Position(6.5+(4*j),3.25+i), Position(10.5+(4*j),4.5+i),
	                      course.subject[j].instructor_name, Red);
            int c=course.subject[j].credits;
            b=char(48+c);                           //for converting credits (int) to char
            char d1[2]={b,'\0'};

                MyWindow.RenderText(Position(6.5+(4*j),4.5+i), Position(10.5+(4*j),5.75+i),
	                       d1,Green);
             
          
              }
       i+=3.75;
     }//end of while loop
 fclose(Pcourse);
 int c;
 cin>>c;
 MyWindow.Close();

 return ;


}

////////////////////////////////////////////////////////////////////////////////////////////////////
void Marksheet1()
{//Since administrator has called this function
 //Function to Take input of the roll number and check for its validity
 //If found reads the corresponding record in student file and passes that student variable in Marksheet2() function 
 int i;         
 cout<<"\n\n\t Enter roll no. of the student......";
 cin>>roll_variable;
 Pindex=fopen("index.abc","rb");
 while(!feof(Pindex))
  {
    fread(&index1,sizeof(index1),1.0,Pindex);
    if( index1.roll_no== roll_variable)
      {
        i=index1.record;
      }
  }
  fclose(Pindex);
  Pstudent=fopen("Student.abc","rb");
  fseek(Pstudent,(i-1)*sizeof(student) , 0);
  fread(&student , sizeof(student) , 1.0 , Pstudent);
  Marksheet2(student);
  fclose(Pstudent);
}

/////////////////////////////////////////////////////////////////////////////////////////////

void Marksheet2( student_info &var )
 {  //Function to display the marksheet of the student variable passed to it as parameter
    int c;//to hold the record number of student
    SimpleWindow window7("Marksheet Display", 30.0 , 15.0 , Position(0.0,0.0));
    window7.Open();
    window7.RenderText( Position(4.0,1.0) , Position(10.0,2.0) , "NAME    :", Black);
    window7.RenderText( Position(4.0,2.0) , Position(10.0,3.0) , "ROLL NO    :", Black);
    window7.RenderText( Position(4.0,3.0) , Position(10.0,4.0) , "BLOOD GROUP    :", Black);
    window7.RenderText( Position(4.0,4.0) , Position(10.0,5.0) , "BRANCH    :", Black);
    window7.RenderText( Position(4.0,5.0) , Position(10.0,6.0) , "EXTRA ACTIVITY", Black);
    window7.RenderText( Position(2.5,6.0) , Position(11.5,7.0) , "Course code", Red);
    window7.RenderText( Position(11.5,6.0) , Position(20.5,7.0) , "Instructor name", Red);
    window7.RenderText( Position(20.5,6.0) , Position(28.5,7.0) , "Marks out of 100", Red);
        Pindex=fopen("index.abc","rb");
        //Reading index file to initialize c
        while(!feof(Pindex))
        {
          fread(&index1 , sizeof(index1) , 1.0 , Pindex);
          if(index1.roll_no==var.roll_no)
             c=index1.record;
         }
        Pcourse = fopen("course.abc","rb");
        Presult = fopen("result.abc","rb");
        Pstudent = fopen("student.abc","rb");
        fseek(Presult,(c-1)*sizeof(result),0);
        fread(&result , sizeof(result) , 1.0 ,Presult);
        fseek(Pcourse,(var.division-1)*sizeof(course),0 );
        fread(&course , sizeof(course) , 1.0 ,Pcourse);
                  window7.RenderText(Position(11.0,1.0) , Position(18.0,2.0) , var.name, Black);
                  window7.RenderText(Position(11.0,2.0) , Position(18.0,3.0) ,var.roll_no, Black);
                  window7.RenderText(Position(11.0,3.0) , Position(10.0,4.0) , var.blood_group, Black);
                  window7.RenderText(Position(11.0,4.0) , Position(10.0,5.0) , var.branch, Black);
                  window7.RenderText(Position(11.0,5.0) , Position(10.0,6.0) ,var.extra_act, Black);                      
            for(int k=0 ; k<6 ; k++)
               {   //Converting marks which are integer to string arr
                   int c1=result.marks[k];
                   int unit_digit=c1%10;
                   char d1=(char)(unit_digit+48);
                   int tens_digit=(c1%100)/10;
                   char d2=(char)(tens_digit+48);
                    int hun_digit=(c1%1000)/100;
                   char d3=(char)(hun_digit+48); 
                    char arr[4]={d3,d2,d1,'\0'};
                   
                  window7.RenderText(Position(2.5,7.0+k) , Position(11.5,7.0+k) , course.subject[k].course_name, Red);
                  window7.RenderText(Position(11.5,7.0+k) , Position(20.5,7.0+k) ,course.subject[k].instructor_name, Red);
                  window7.RenderText(Position(20.5,7.0+k) , Position(28.5,7.0+k) , arr, Red);
                  
               }
    fclose(Pcourse);
    fclose(Presult);
    window7.Close();
}

///////////////////////////////////////////////////////////////////////////////////////////////////

void course_file_display2(student_info &var)
{//displays course file according to the division of the user
   Pcourse=fopen("course.abc","rb");
   fseek( Pcourse , (var.division-1)*sizeof(var) , 00);
   fread(&course , sizeof(course) ,  1.0 , Pcourse);
   SimpleWindow window8("Course Display  " , 30.0 , 15.0 , Position(0.0,0.0));
   window8.Open();
   window8.RenderText( Position(13.0,1.0) , Position(17.0,2.0), "Division :- " , Black);
   window8.RenderText( Position(0.0,4.0) , Position(4.0,5.0), "credits  " , Black);
   window8.RenderText( Position(4.0,4.0) , Position(17.0,5.0), "Course Name  " , Black);
   window8.RenderText( Position(17.0,4.0) , Position(30.0,5.0), "Instructor Name :- " , Black);
             //To convert division and credits which are integer ,to string .... Variables following it are meant for that
   int c2,c1=course.division;
   char b2,b1=char(45+c1);
   char d2[2],d1[3]={'D',b1,'\0'};
   window8.RenderText( Position(18.0,1.0) , Position(21.0,2.0), d1 , Black);
   for(int i=0;i<6;i++)
     {     c2=course.subject[i].credits;
         b2=char(45+c2);
         d2[0]=b2;d2[1]='\0';
         window8.RenderText( Position(0.0,5.0+i*2) , Position(4.0,6.0+i*2),d2 , Black);
         window8.RenderText( Position(4.0,5.0+i*2) , Position(17.0,6.0+i*2),course.subject[i].course_name  , Black);
         window8.RenderText( Position(17.0,5.0+i*2) , Position(30.0,6.0+i*2),course.subject[i].instructor_name  , Black);
     }
   fclose(Pcourse);
   window8.Close();
}   


///////////////////////////////////////////////////////////////////////////////////////////////
void modification_marks()
{ //Function to modify the marks of the student
  //Reads result file. asks for which roll no. to modify
  //And then takes the input of the marks in each course and checks its validity
  //It is even meant to modify one subjects marks or so
    char rollno[12];
   char choice;//for asking whether to make more modifications or not
   float spi;
   int check,count,division,loop,code;

  cout<<"ENTER THE ROLL NO.OF THE STUDENT";
  cin>>rollno;

  Pindex=fopen("index.abc","rb+");
  check=0;//for checking whether students roll no. exists or not
  count=0;//To count the record number of student in result file
   while(!fread(&index1,sizeof(index1),1,Pindex))
   {
         if (strcmp(index1.roll_no,rollno)==0)
         {
                  check=1;
                  break;
         }
         count++;
    }
    if (check==0)
     cout<<"roll no. not found";
    else
    {
     Pstudent=fopen("student.abc","rb+");
     do
     {
          fseek(Pstudent,(count)*sizeof(student),SEEK_SET);
          fread(&student,sizeof(student),1,Pstudent);
          division=student.division;
          Pcourse=fopen("course.abc","rb+");
          fseek(Pcourse,(division-1)*sizeof(course),SEEK_SET);
          fread(&course,sizeof(course),1,Pcourse);
          Presult=fopen("result.abc","rb+");
          fseek(Presult,(count)*sizeof(result),SEEK_SET);
          fread(&result,sizeof(result),1,Presult);
          cout<<"the marks of student in his/her courses are";
          //displaying the courses enrolled in by the student
          for(loop=0;loop<=5;loop++)
          {
                 cout<<"\n"<<loop+1<<"t"<<course.subject[loop].course_name<<"\t"<<result.marks[loop];
          }
          cout<<"which coures's marks do u want to change";
          cout<<"enter it's code(1-6)";
          cin>>code;
          cout<<"enter the marks";
          cin>>result.marks[code-1];
          if(result.marks[code-1]<0||result.marks[code-1]>100) 
                      cout<<"\n\n\t\tInvalid marks entry";
          else
          { 
              fseek(Presult,(count)*sizeof(result),SEEK_SET);
              //calculating spi using format at iitb
              spi=0;
              for(loop=0;loop<6;loop++)
              {
                   spi=spi+course.subject[loop].credits;
              }
              result.SPI=spi; 
              cout<<"SPI of student is "<<spi;
              fwrite(&result,sizeof(result),1,Presult);
           }
              cout<<"Do u want to make more changes";
              cin>>choice; 
      }while(choice=='y'||choice=='Y');
      fclose(Pstudent);
      fclose(Pcourse);
      fclose(Presult);
   }
  fclose(Pindex);

}


/////////////////////////////////////////////////////////////////////////////////////////////
 void deletion_stud()    //here roll no of a student to be deleted enters in function.
{
      cout<<" Enter Roll number that you want to Delete ";
     cin>>roll_variable;
     cout<<" Are you sure you want to delete that..... \n That would remove this students data from entire list(Enter y for yes and n for no)";
     char ch;
     cin>>ch;
   if(ch=='y')
   {
      Pstudent=fopen("student.abc","rb");             // Opening all files from where data has to be deleted. 
      Presult=fopen("result.abc","rb");              // opening all files in reading modenfo","rb");              // opening all files in reading mode
      Pindex=fopen("index.abc","rb");
     if ( Pstudent== NULL )
        {
          cout<<endl<<"ERROR : student_info file not opened !!!";
         
        } 
    if ( Presult== NULL )
       {
          cout<<endl<<"ERROR : result_info file not opened !!!";
          
       }       
    if ( Pindex== NULL )
       {
           cout<<endl<<"ERROR : index_info file not opened !!!";
           
       } 
    FILE *Ptempstudent= fopen("tempstudentfile","wb");                                                                  
    FILE *Ptempresult= fopen("tempresultfile", "wb" );           
    FILE *Ptempindex= fopen("tempindexfile", "wb" );
    while(!feof(Pstudent))                                              // here reading from input files and writing in temporary files
       { 
              fread(&student,sizeof student,1,Pstudent);
               if(strcmp(student.roll_no,roll_variable)!=0)
                      fwrite(&student,sizeof(student),1,Ptempstudent);
                 
       }  
    while(!feof(Presult))
       { 
              fread(&result,sizeof result ,1,Presult);
 
           if (strcmp(result.roll_no,roll_variable)!=0)
                  {        fwrite(&result,sizeof (result),1,Ptempresult);
                  }
        }
  while(!feof(Pindex))
       { 
              fread(&index1,sizeof(index1),1,Pindex);

             if (index1.roll_no!=roll_variable)
                 {         fwrite(&index1,sizeof index1,1,Ptempindex);
                 }
       }  
       fclose(Pstudent);
       fclose(Presult);
       fclose(Pindex); 
    //closing old files
     //removing and renaming the rest ones
       remove("student.abc");
         if( remove( "student.abc" ) != 0 )
        cout<<"Error deleting student_info file"<<endl; 
         else
          cout<<"student_info file successfully deleted"<<endl; 
      remove("result.abc"); 
         if( remove( "result_info" ) != 0 )
        cout<<"Error deleting result_info file"<<endl; 
         else
          cout<<"student_info file successfully deleted"<<endl; 
      remove("index.abc"); 
          if( remove( "index.abc" ) != 0 )
        cout<<"Error deleting Index_info file"<<endl; 
         else
          cout<<"Index_info file successfully deleted"<<endl;      
     //removed old files
       fclose(Ptempstudent);
       fclose(Ptempresult);
       fclose(Ptempindex);  
     // closed temporary file
       rename("tempstudentfile","student.abc");       
       rename("tempresultfile","result.abc"); 
       rename("tempindexfile","index.abc"); // task remained error message.
     // renamed temporary files as new files
  }//end of if stastement
  
}
///////////////////////////////////////////////////////////////////////////////////////////////////
  int get_index_of_rollno(char n[])
    { //Function to know at what record no. roll no. is stored 
      int found=-1,i=0;

       while(feof(Pindex)==0)
              {
                 fread(&index1,sizeof(index1),1,Pindex);
                 if (strcmp(index1.roll_no,n)==0)
                        {
                           found=i;
                        }
                  i++;
               }
      return found;
     }
////////////////////////////////////////////////////////////////////////////////////////
void display_students_info(struct student_info &a)
      { //Displays the data of the student whose variable is passed as parameter
         cout<<"Name: "<<a.name<<endl;
         cout<<"Roll no.: "<<a.roll_no<<endl;
         cout<<"Branch: "<<a.branch<<endl;
         cout<<"Division: "<<a.division<<endl;
         cout<<"Date Of Birth: "<<a.dob.date<<a.dob.month<<a.dob.year<<endl;
         cout<<"Hostel: "<<a.hostel_no<<endl;
         cout<<"Room no.: "<<a.room_no<<endl;
         cout<<"Home state: "<<a.home_state<<endl;
         cout<<"Blood group: "<<a.blood_group<<endl;
         cout<<"Extra activity: "<<a.extra_act<<endl;
      }


     
///////////////////////////////////////////////////////////////////////////////////////////////////////

void modification_stud()
{ //Modifies the data according to the user choice
  Pstudent=fopen("student.abc","rb+");
  Pindex=fopen("index.abc","rb+");
  Presult=fopen("result.abc","rb+");


     int rollno; char choice,ch;
     int recsize1= sizeof(student);   
     int recsize2=sizeof(result);
     int recsize3=sizeof(course);
     cout<<"Enter the Roll number of the record to be modified: ";
     cin>>roll_variable;
     int found=get_index_of_rollno(roll_variable);
     if(found==-1)
        cout<<"\tRoll number not found\n";
     else
     { 
        
           cout<<"The entered roll no. corresponds to "<<found<<"th record in our files."<<endl;
     
           //reading students and marks info
           cout<<"Reading student's information..."<<endl;
     
           fseek(Pstudent,found*recsize1,SEEK_SET);
           fread(&student,recsize1,1,Pstudent);
           display_students_info(student);
    
         
       /*
        Now the user will be asked to choose which field he wants to modify.
        This will be done either by mouse clicking on the desired option or using switch/break commands.
        According to the option chosen by the user, we will display commands and the user will modify the info subsequently
       */
      do{
        
      cout<<"Please choose which field you want to modify from the following:"<<endl;
      cout<<"    1. NAME"<<endl;
      cout<<"    2. ROLL NUMBER"<<endl;
      cout<<"    3. BRANCH"<<endl;
      cout<<"    4. DIVISION"<<endl;
      cout<<"    5. DATE OF BIRTH"<<endl;
      cout<<"    6. HOSTEL/ROOM NUMBER"<<endl;
      cout<<"    7. HOME STATE"<<endl;
      cout<<"    8. BLOOD GROUP"<<endl;
      cout<<"   9. EXTRA ACTIVITY"<<endl;
      cout<<"    0. EXIT TO MAIN MENU"<<endl;
      cout<<"Please enter your choice :";
      
      cin>>choice;
      //According to choice the input will be taken and changed records will be rewritten on file removind the previous one
      switch(choice)
        
         {
        
           case '1':
            
             get_name(student.name);
             fseek(Pstudent,found*recsize1,SEEK_SET);
             fwrite(&student,recsize1,1,Pstudent);
             break;

           
           case '2':
            
             cout<<"Enter new roll number :";
             cin>>student.roll_no;
             if (check_roll_no(student.roll_no)==1)
                {
                  strcpy(result.roll_no,student.roll_no);
                  strcpy(index1.roll_no,student.roll_no);
                  fseek(Pstudent,found*recsize1,SEEK_SET);
                  fwrite(&student,recsize1,1,Pstudent);
                  fseek(Pindex,found*recsize3,SEEK_SET);
                  fwrite(&index1,recsize3,1,Pindex);
                  fseek(Presult,found*recsize2,SEEK_SET);
                  fwrite(&result,recsize2,1,Presult);
                  break;
                }
             else 
                 cout<<"Invalid entry.";
             break;

           case '3':
         
             cout<<"Enter new Branch :";
             cin>>student.branch;
             fseek(Pstudent,found*recsize1,SEEK_SET);
             fwrite(&student,recsize1,1,Pstudent);
             break;

           case '4':
         
             get_division(student.division);
             fseek(Pstudent,found*recsize1,SEEK_SET);
             fwrite(&student,recsize1,1,Pstudent);
             break;
 
           case '5':
        
             get_dob(student.dob);
             fseek(Pstudent,found*recsize1,SEEK_SET);
             fwrite(&student,recsize1,1,Pstudent);
             break;

           case '6':
        
             get_hostel(student);
             fseek(Pstudent,found*recsize1,SEEK_SET);
             fwrite(&student,recsize1,1,Pstudent);
             break;

           case '7':
          
              get_state(student.home_state);
              fseek(Pstudent,found*recsize1,SEEK_SET);
              fwrite(&student,recsize1,1,Pstudent);
              break;

           case '8':
         
              get_blood_group(student.blood_group);
              fseek(Pstudent,found*recsize1,SEEK_SET);
              fwrite(&student,recsize1,1,Pstudent);
              break;

           
             
            
            case '9':

                get_extra(student.extra_act);
                fseek(Pstudent,-recsize1,SEEK_CUR);
                fwrite(&student,recsize1,1,Pstudent);
                break;

            case '0':
            
                break;
 
           }//end of switch
        if(choice!='0')
         {
         cout<<"\nDo you want to modify more of records(enter y or n)\t";
         cin>>ch;
         }
        }while(ch=='y'||ch=='Y');
     }//end of else
     fclose(Pindex);
     fclose(Presult);
     fclose(Pstudent);
   return;
 }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





//////////////////////////////////*************************Thanks*******************************/////////////////////////////////////////


